Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_data.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 3605)
@@ -7,4 +7,5 @@
   INTEGER,SAVE :: omp_rank
   LOGICAL,SAVE :: is_omp_root
+  LOGICAL,SAVE :: is_omp_master  ! alias of is_omp_root
   LOGICAL,SAVE :: is_using_omp
   LOGICAL,SAVE :: is_north_pole_phy, is_south_pole_phy
@@ -17,5 +18,5 @@
   INTEGER,SAVE :: klon_omp_begin
   INTEGER,SAVE :: klon_omp_end
-!$OMP  THREADPRIVATE(omp_rank,klon_omp,is_omp_root,klon_omp_begin,klon_omp_end)
+!$OMP  THREADPRIVATE(omp_rank,klon_omp,is_omp_root,is_omp_master,klon_omp_begin,klon_omp_end)
 !$OMP  THREADPRIVATE(is_north_pole_phy, is_south_pole_phy)
 
@@ -60,8 +61,8 @@
    ELSE
      abort_message = 'ANORMAL : OMP_MASTER /= 0'
-     CALL abort_gcm (modname,abort_message,1)
+     CALL abort_physic (modname,abort_message,1)
    ENDIF
 !$OMP END MASTER
-
+   is_omp_master=is_omp_root
 
 !$OMP MASTER 
@@ -106,6 +107,7 @@
 
   SUBROUTINE Print_module_data
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
-  INCLUDE "iniprint.h"
+!  INCLUDE "iniprint.h"
 
 !$OMP CRITICAL  
Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_transfert.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 3605)
@@ -47,6 +47,11 @@
   END INTERFACE 
 
-
-  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp, omp_barrier
+  INTERFACE reduce_min_omp
+    MODULE PROCEDURE reduce_min_omp_i,reduce_min_omp_i1,reduce_min_omp_i2,reduce_min_omp_i3,reduce_min_omp_i4, &
+                     reduce_min_omp_r,reduce_min_omp_r1,reduce_min_omp_r2,reduce_min_omp_r3,reduce_min_omp_r4
+  END INTERFACE 
+
+
+  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp, reduce_min_omp, omp_barrier
 
 CONTAINS
@@ -710,4 +715,134 @@
   END SUBROUTINE reduce_sum_omp_r4
 
+
+
+  SUBROUTINE reduce_min_omp_i(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN)  :: VarIn
+    INTEGER,INTENT(OUT) :: VarOut
+    INTEGER             :: VarIn_tmp(1)
+    INTEGER             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_i(1)   
+    CALL reduce_min_omp_igen(VarIn_tmp,Varout_tmp,1,buffer_i)
+    VarOut=VarOut_tmp(1)
+    
+  END SUBROUTINE reduce_min_omp_i
+
+  SUBROUTINE reduce_min_omp_i1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_min_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+   
+  END SUBROUTINE reduce_min_omp_i1
+  
+  
+  SUBROUTINE reduce_min_omp_i2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
+
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_min_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_min_omp_i2
+
+
+  SUBROUTINE reduce_min_omp_i3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_min_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_min_omp_i3
+
+
+  SUBROUTINE reduce_min_omp_i4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_min_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_min_omp_i4
+
+
+  SUBROUTINE reduce_min_omp_r(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN)  :: VarIn
+    REAL,INTENT(OUT) :: VarOut
+    REAL             :: VarIn_tmp(1)
+    REAL             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_r(1)   
+    CALL reduce_min_omp_rgen(VarIn_tmp,Varout_tmp,1,buffer_r)
+    VarOut=VarOut_tmp(1)
+  
+  END SUBROUTINE reduce_min_omp_r
+
+  SUBROUTINE reduce_min_omp_r1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_min_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+   
+  END SUBROUTINE reduce_min_omp_r1
+  
+  
+  SUBROUTINE reduce_min_omp_r2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_min_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_min_omp_r2
+
+
+  SUBROUTINE reduce_min_omp_r3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_min_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_min_omp_r3
+
+
+  SUBROUTINE reduce_min_omp_r4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    REAL,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_min_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_min_omp_r4
+
+
+
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !    LES ROUTINES GENERIQUES    !
@@ -1062,3 +1197,69 @@
   END SUBROUTINE reduce_sum_omp_rgen
 
+
+  SUBROUTINE reduce_min_omp_igen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    INTEGER,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    INTEGER,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+    INTEGER :: var
+
+  !$OMP MASTER
+    Buff(:)=HUGE(var)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MIN(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+  !$OMP MASTER
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  END SUBROUTINE reduce_min_omp_igen
+
+  SUBROUTINE reduce_min_omp_rgen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    REAL,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    REAL,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+    REAL :: var
+
+  !$OMP MASTER
+    Buff(:)=HUGE(var)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MIN(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+  !$OMP MASTER
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  END SUBROUTINE reduce_min_omp_rgen
+
+
 END MODULE mod_phys_lmdz_omp_transfert
Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_para.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_para.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_para.F90	(revision 3605)
@@ -33,5 +33,5 @@
        is_master=.FALSE.
      ENDIF
-     CALL Test_transfert
+!ym     CALL Test_transfert
 !$OMP END PARALLEL    
      IF (is_using_mpi .OR. is_using_omp) THEN
@@ -49,6 +49,7 @@
   SUBROUTINE Test_transfert
   USE mod_grid_phy_lmdz
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
-    INCLUDE "iniprint.h"
+!    INCLUDE "iniprint.h"
  
     REAL :: Test_Field1d_glo(klon_glo,nbp_lev)
Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_transfert_para.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_transfert_para.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/mod_phys_lmdz_transfert_para.F90	(revision 3605)
@@ -1,4 +1,4 @@
 !
-!$Header$
+!$Id$
 !
 MODULE mod_phys_lmdz_transfert_para
@@ -46,4 +46,8 @@
   END INTERFACE 
 
+  INTERFACE reduce_min
+    MODULE PROCEDURE reduce_min_i,reduce_min_i1,reduce_min_i2,reduce_min_i3,reduce_min_i4, &
+                     reduce_min_r,reduce_min_r1,reduce_min_r2,reduce_min_r3,reduce_min_r4
+  END INTERFACE 
    
 CONTAINS
@@ -1271,4 +1275,173 @@
   END SUBROUTINE reduce_sum_r4  
 
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! Definition des reduce_min   --> 4D   !!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+! Les entiers
+
+  SUBROUTINE reduce_min_i(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN)  :: VarIn
+    INTEGER,INTENT(OUT) :: VarOut
+    
+    INTEGER             :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_i  
+
+
+  SUBROUTINE reduce_min_i1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    INTEGER,DIMENSION(SIZE(VarIn))   :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_i1  
+
+
+  SUBROUTINE reduce_min_i2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
+    
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2)) :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_i2  
+  
+
+  SUBROUTINE reduce_min_i3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))  :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_i3  
+
+
+  SUBROUTINE reduce_min_i4(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+    
+    INTEGER,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))  :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_i4  
+
+
+! Les reels
+
+  SUBROUTINE reduce_min_r(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN)  :: VarIn
+    REAL,INTENT(OUT) :: VarOut
+    
+    REAL             :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_r  
+
+
+  SUBROUTINE reduce_min_r1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    REAL,DIMENSION(SIZE(VarIn))   :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_r1  
+
+
+  SUBROUTINE reduce_min_r2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
+    
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2)) :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_r2  
+  
+
+  SUBROUTINE reduce_min_r3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3))  :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_r3  
+
+
+  SUBROUTINE reduce_min_r4(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+    
+    REAL,DIMENSION(SIZE(VarIn,1),SIZE(VarIn,2),SIZE(VarIn,3),SIZE(VarIn,4))  :: Var_tmp
+           
+    CALL reduce_min_omp(VarIn,Var_tmp)
+!$OMP MASTER      
+    CALL reduce_min_mpi(Var_tmp,VarOut)
+!$OMP END MASTER
+  
+  END SUBROUTINE reduce_min_r4  
+
+
    
 END MODULE mod_phys_lmdz_transfert_para
Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/physics_distribution_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/physics_distribution_mod.F90	(revision 3605)
@@ -10,6 +10,12 @@
                                        nbp, nbp_lon, nbp_lat, nbp_lev, &
                                        communicator)
-  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para
+  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para, klon_omp
   USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
+  USE dimphy, ONLY : Init_dimphy
+  USE infotrac_phy, ONLY : type_trac
+#ifdef REPROBUS
+  USE CHEM_REP, ONLY : Init_chem_rep_phys
+#endif
+
   IMPLICIT NONE
     INTEGER,INTENT(IN) :: grid_type 
@@ -24,4 +30,15 @@
     CALL init_grid_phy_lmdz(grid_type,nvertex, nbp_lon,nbp_lat,nbp_lev)
     CALL init_phys_lmdz_para(nbp,nbp_lon, nbp_lat, communicator)
+!$OMP PARALLEL
+    CALL init_dimphy(klon_omp,nbp_lev)
+
+! Initialization of Reprobus
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+#endif
+    END IF
+
+!$OMP END PARALLEL
 
   END SUBROUTINE init_physics_distribution  
Index: /LMDZ6/branches/Ocean_skin/libf/phy_common/print_control_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phy_common/print_control_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phy_common/print_control_mod.F90	(revision 3605)
@@ -7,57 +7,21 @@
 !$OMP THREADPRIVATE(lunout,prt_level,debug)
 
+  ! NB: Module variable Initializations done by set_print_control
+  !     routine from init_print_control_mod to avoid circular
+  !     module dependencies
+
 CONTAINS
 
-  SUBROUTINE init_print_control
-  USE ioipsl_getin_p_mod, ONLY : getin_p
-  USE mod_phys_lmdz_para, ONLY: is_omp_root, is_master
+  SUBROUTINE set_print_control(lunout_,prt_level_,debug_)
   IMPLICIT NONE
-
-    LOGICAL :: opened
-    INTEGER :: number
+    INTEGER :: lunout_
+    INTEGER :: prt_level_
+    LOGICAL :: debug_
+      
+    lunout = lunout_
+    prt_level = prt_level_
+    debug = debug_
     
-    !Config  Key  = prt_level
-    !Config  Desc = niveau d'impressions de débogage
-    !Config  Def  = 0
-    !Config  Help = Niveau d'impression pour le débogage
-    !Config         (0 = minimum d'impression)
-    prt_level = 0
-    CALL getin_p('prt_level',prt_level)
-
-    !Config  Key  = lunout
-    !Config  Desc = unite de fichier pour les impressions
-    !Config  Def  = 6
-    !Config  Help = unite de fichier pour les impressions 
-    !Config         (defaut sortie standard = 6)
-    lunout=6
-    CALL getin_p('lunout', lunout)
-
-    IF (is_omp_root) THEN
-      IF (lunout /= 5 .and. lunout /= 6) THEN
-         INQUIRE(FILE='lmdz.out_0000',OPENED=opened,NUMBER=number)
-         IF (opened) THEN
-           lunout=number
-         ELSE
-           OPEN(UNIT=lunout,FILE='lmdz.out_0000',ACTION='write',  &
-                STATUS='unknown',FORM='formatted')
-         ENDIF
-      ENDIF
-    ENDIF
-
-    !Config  Key  = debug
-    !Config  Desc = mode debogage
-    !Config  Def  = false
-    !Config  Help = positionne le mode debogage
-
-    debug = .FALSE.
-    CALL getin_p('debug',debug)
-    
-    IF (is_master) THEN
-      WRITE(lunout,*)"init_print_control: prt_level=",prt_level
-      WRITE(lunout,*)"init_print_control: lunout=",lunout
-      WRITE(lunout,*)"init_print_control: debug=",debug      
-    ENDIF
-    
-  END SUBROUTINE init_print_control  
+  END SUBROUTINE set_print_control
 
 END MODULE print_control_mod
Index: /LMDZ6/branches/Ocean_skin/libf/phydev/inifis_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phydev/inifis_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phydev/inifis_mod.F90	(revision 3605)
@@ -1,3 +1,3 @@
-! $Id: $
+! $Id$
 MODULE inifis_mod
 
@@ -6,5 +6,5 @@
   SUBROUTINE inifis(prad, pg, pr, pcpp)
   ! Initialize some physical constants and settings
-  USE print_control_mod, ONLY: init_print_control
+  USE init_print_control_mod, ONLY: init_print_control
   USE comcstphy, ONLY: rradius, & ! planet radius (m)
                        rr, & ! recuced gas constant: R/molar mass of atm
Index: /LMDZ6/branches/Ocean_skin/libf/phydev/phyredem.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phydev/phyredem.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phydev/phyredem.F90	(revision 3605)
@@ -5,5 +5,6 @@
 
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
-  USE iostart, ONLY: open_restartphy, close_restartphy, put_var, put_field
+  USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
+
 
   IMPLICIT NONE
@@ -13,4 +14,5 @@
   INTEGER,PARAMETER :: tab_cntrl_len=100
   REAL :: tab_cntrl(tab_cntrl_len)
+  INTEGER :: pass
 
   ! open file
@@ -21,14 +23,19 @@
 
   tab_cntrl(:)=0.0
- 
 
-  CALL put_var("controle", "Control parameters", tab_cntrl)
+  DO pass=1,2   ! pass=1 netcdf definition ; pass=2 netcdf write
+
+    CALL put_var(pass, "controle", "Control parameters", tab_cntrl)
 
   ! coordinates
 
-  CALL put_field("longitude", "Longitudes on physics grid", longitude_deg)
+    CALL put_field(pass, "longitude", "Longitudes on physics grid", longitude_deg)
      
-  CALL put_field("latitude", "Latitudes on physics grid", latitude_deg)
+    CALL put_field(pass, "latitude", "Latitudes on physics grid", latitude_deg)
 
+    IF (pass==1) CALL enddef_restartphy
+    IF (pass==2) CALL close_restartphy
+
+  ENDDO
   ! close file
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/aer_sedimnt.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/aer_sedimnt.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/aer_sedimnt.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 SUBROUTINE AER_SEDIMNT(pdtphys, t_seri, pplay, paprs, tr_seri, dens_aer)
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 SUBROUTINE calcaerosolstrato_rrtm(pplay,t_seri,paprs,debut)
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/coagulate.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/coagulate.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/coagulate.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 SUBROUTINE COAGULATE(pdtcoag,mdw,tr_seri,t_seri,pplay,dens_aer,is_strato)
   !     -----------------------------------------------------------------------
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/cond_evap_tstep_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/cond_evap_tstep_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/cond_evap_tstep_mod.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 MODULE cond_evap_tstep_mod
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/interp_sulf_input.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/interp_sulf_input.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/interp_sulf_input.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 SUBROUTINE interp_sulf_input(debutphy,pdtphys,paprs,tr_seri)
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/micphy_tstep.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/micphy_tstep.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/micphy_tstep.F90	(revision 3605)
@@ -1,4 +1,8 @@
+!
+! $Id$
+!
 SUBROUTINE micphy_tstep(pdtphys,tr_seri,t_seri,pplay,paprs,rh,is_strato)
 
+  USE geometry_mod, ONLY : latitude_deg !NL- latitude corr. to local domain
   USE dimphy, ONLY : klon,klev
   USE aerophys
@@ -9,5 +13,7 @@
   USE sulfate_aer_mod, ONLY : STRAACT
   USE YOMCST, ONLY : RPI, RD, RG
-
+  USE print_control_mod, ONLY: lunout
+  USE strataer_mod
+  
   IMPLICIT NONE
 
@@ -89,5 +95,12 @@
       ! compute nucleation rate in kg(H2SO4)/kgA/s
       CALL nucleation_rate(rhoa,t_seri(ilon,ilev),pplay(ilon,ilev),rh(ilon,ilev), &
-             & a_xm,b_xm,c_xm,nucl_rate,ntot,x)
+           & a_xm,b_xm,c_xm,nucl_rate,ntot,x)
+      !NL - add nucleation box (if flag on)
+      IF (flag_nuc_rate_box) THEN
+         IF (latitude_deg(ilon).LE.nuclat_min .OR. latitude_deg(ilon).GE.nuclat_max &
+              .OR. pplay(ilon,ilev).GE.nucpres_max .AND. pplay(ilon,ilev).LE.nucpres_min) THEN
+            nucl_rate=0.0
+         ENDIF
+      ENDIF
       ! compute cond/evap rate in kg(H2SO4)/kgA/s
       CALL condens_evapor_rate(rhoa,t_seri(ilon,ilev),pplay(ilon,ilev), &
@@ -160,5 +173,5 @@
     DO it=1, nbtr
       IF (tr_seri(ilon,ilev,it).LT.0.0) THEN
-        PRINT *, 'micphy_tstep: negative concentration', tr_seri(ilon,ilev,it), ilon, ilev, it
+         WRITE(lunout,*) 'micphy_tstep: negative concentration', tr_seri(ilon,ilev,it), ilon, ilev, it
       ENDIF
     ENDDO
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/miecalc_aer.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/miecalc_aer.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/miecalc_aer.F90	(revision 3605)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
 SUBROUTINE MIECALC_AER(tau_strat, piz_strat, cg_strat, tau_strat_wave, tau_lw_abs_rrtm, paprs, debut)
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/minmaxsimple.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/minmaxsimple.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/StratAer/minmaxsimple.F90	(revision 3605)
@@ -1,4 +1,4 @@
 !
-! $Id: minmaxsimple.F90 1910 2013-11-29 08:40:25Z fairhead $
+! $Id$
 !
 SUBROUTINE minmaxsimple(zq,qmin,qmax,comment)
